<script setup lang="ts">
import { ChevronLgRight, DocPencilAlt, Blog } from 'slippers-ui/icons';
import type { BaseLink, BaseImage, BaseIcon } from '@/types/base';

const icons = { ChevronLgRight, DocPencilAlt, Blog };
interface CaseStudiesProps {
  charcoalBg?: boolean;
  title: string;
  aos?: {
    config: {
      dataAos: string;
      duration: string;
    };
  };
  rows: {
    title: string;
    subtitle: string;
    button: BaseLink;
    image: BaseImage;
    config: {
      icon: BaseIcon;
    };
    aos?: {
      config: {
        dataAos: string;
        duration: string;
      };
    };
  }[];
}

defineProps<CaseStudiesProps>();
</script>

<template>
  <section class="case-studies" :class="{ 'case-studies__charcoal-bg': charcoalBg }">
    <SlpContainer class="case-studies__container">
      <div class="case-studies__header" :data-aos="aos?.config.dataAos" :data-aos-duration="aos?.config.duration">
        <SlpTypography tag="h2" variant="heading2-bold" class="title"> {{ title }}</SlpTypography>
      </div>
      <div class="case-studies__content">
        <div
          v-for="row in rows"
          :key="row.subtitle"
          class="case-studies__row"
          :data-aos="row.aos?.config.dataAos"
          :data-aos-duration="row.aos?.config.duration"
        >
          <div class="case-studies__text">
            <SlpIcon :icon="icons[row.config.icon.name]" class="case-studies__icon" />
            <SlpTypography tag="h3" variant="heading5-bold" class="slp-mb-24">
              {{ row.title }}
            </SlpTypography>
            <SlpTypography tag="h4" variant="heading5">
              {{ row.subtitle }}
            </SlpTypography>
          </div>
          <a
            class="case-studies__link-card"
            :href="row.button.config.href"
            :data-ga-name="row.button.config.dataGaName"
            :data-ga-location="row.button.config.dataGaLocation"
          >
            <NuxtImg
              class="case-studies__image"
              :src="row.image.config.url"
              :alt="row.image.alt || ''"
              loading="lazy"
            />
            <span class="case-studies__link-text">
              {{ row.button.text }}
              <SlpIcon :icon="icons.ChevronLgRight" class="case-studies__chevron" alt="Chevron Right Icon" />
            </span>
          </a>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.case-studies {
  padding: $spacing-96 $spacing-16;
  display: flex;
  flex-direction: column;

  &__charcoal-bg {
    background-color: $color-surface-800;
  }

  &__header {
    display: flex;
    align-items: flex-end;
    margin-bottom: $spacing-96;
  }

  .title {
    max-width: $breakpoint-md;
  }

  &__content {
    display: flex;
    flex-direction: column;
  }

  &__row {
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    border-top: 1px solid $color-surface-400;
    padding: $spacing-48 0;

    &:last-of-type {
      border-bottom: 1px solid $color-surface-400;
    }
  }

  &__text {
    flex: 1;
    display: flex;
    flex-direction: column;
    gap: $spacing-16;
    max-width: 410px;
    margin-right: $spacing-96;

    @media (max-width: $breakpoint-md) {
      margin-right: 0;
    }
  }

  &__icon {
    width: 24px !important;
    height: 24px !important;
  }

  &__row-title {
    font-size: 1.5rem;
    font-weight: bold;
  }

  &__row-subtitle {
    font-size: 1.125rem;
    color: $color-primary-200;
  }

  &__link-card {
    display: flex;
    flex-direction: row;
    justify-content: flex-end;
    align-items: flex-start;
    text-decoration: none;
    color: inherit;
    margin-top: $spacing-32;
    flex: 1;
    gap: $spacing-8;
    padding-right: $spacing-16;
    position: relative;

    @media screen and (max-width: $breakpoint-sm) {
      flex-direction: column;
      align-items: center;
    }
    &::after {
      @media (min-width: $breakpoint-md) {
        content: '';
        height: 263px;
        right: 0;
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        width: 400px;
        pointer-events: none;
        transition: background-color 0.3s ease-in-out;
        z-index: 0;
      }
    }

    &:hover {
      .case-studies__image {
        border-bottom-right-radius: 100px !important;
      }

      &::after {
        @media (min-width: $breakpoint-md) {
          background-color: $color-surface-900;
        }
      }

      .case-studies__chevron {
        transform: translateX(8px);
      }
    }
  }

  &__image {
    border-radius: $spacing-4;
    width: 196px;
    height: 215px;
    object-fit: cover;
    transition: border-bottom-right-radius 0.3s ease-in-out;
    margin-right: $spacing-64;
    z-index: 1;

    @media (max-width: $breakpoint-md) {
      margin-right: 0;
    }
  }

  &__link-text {
    display: flex;
    align-items: center;
    font-weight: bold;
    z-index: 1;

    .slp-icon {
      transform: translateX(4px);
      transition: transform 0.2s ease-in-out;
    }
  }

  &__chevron {
    width: 16px;
    height: 16px;
  }
}

@media (max-width: $breakpoint-md) {
  .case-studies {
    padding: $spacing-48 $spacing-16;

    &__row {
      flex-direction: row;
      align-items: center;
    }

    &__link-card {
      align-items: flex-start;
    }
    &__image {
      height: auto;
      max-height: 199px;
      width: 90vw;
    }
  }
}
@media screen and (max-width: $breakpoint-sm) {
  .case-studies {
    &__container {
      padding: 0px !important;
    }
    &__link-text {
      padding-top: $spacing-16;
    }
  }
}
</style>
